package org.springblade.estate.feign;

import io.swagger.annotations.ApiParam;
import lombok.AllArgsConstructor;
import javax.validation.Valid;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.tool.utils.Func;
import org.springframework.cloud.openfeign.SpringQueryMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.bind.annotation.RequestParam;
import org.springblade.estate.entity.ParkingLot;
import org.springblade.estate.vo.ParkingLotVO;
import org.springblade.estate.wrapper.ParkingLotWrapper;
import org.springblade.estate.service.IParkingLotService;
import org.springblade.core.boot.ctrl.BladeController;
import java.util.List;
/**
 *  client
 *
 * @author lianghanqiang
 * @since 2021-03-30
 */

@AllArgsConstructor
@RestController
@RequestMapping("/feign/parkinglot")

public class ParkingLotClient implements IParkingLotClient {

    private final IParkingLotService parkingLotService;

        /**
     * 详情
     */
    @Override
    @GetMapping("/detail")
    public ParkingLotVO detail(@SpringQueryMap ParkingLot parkingLot) {
        ParkingLot detail = parkingLotService.getOne(Condition.getQueryWrapper(parkingLot));
        return ParkingLotWrapper.build().entityVO(detail);
        }

    /**
     * 查询
     */
    @Override
    @GetMapping("/list")
    public List<ParkingLotVO> list(@SpringQueryMap ParkingLot parkingLot) {
        return ParkingLotWrapper.build().listVO(parkingLotService.list(Condition.getQueryWrapper(parkingLot)));
        }



    /**
     * 新增
     */
    @Override
    @PostMapping("/save")
    public boolean save(@Valid @RequestBody ParkingLot parkingLot) {
        return parkingLotService.save(parkingLot);
        }

    /**
     * 修改
     */
    @Override
    @PostMapping("/update")
    public boolean update(@Valid @RequestBody ParkingLot parkingLot) {
        return parkingLotService.updateById(parkingLot);
        }

    /**
     * 新增或修改
     */
    @Override
    @PostMapping("/submit")
    public boolean submit(@Valid @RequestBody ParkingLot parkingLot) {
        return parkingLotService.saveOrUpdate(parkingLot);
        }


    /**
     * 删除
     */
    @Override
    @PostMapping("/remove")
    public boolean remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
        return parkingLotService.deleteLogic(Func.toLongList(ids));
        }


}
